
#include <stdio.h>
#include "ad++.h"

//       subroutine init(a)
//
//       real a(50)
// !hpf$ inherit a
// 
//       forall (i=1:50) a(i) = 1.0 *i
//       end

// !hpf$ processors q(2,2)
//
//       real b(6, 50)
//
// !hpf$ distribute b(block, block) onto p
//
//       call init(b(2, :))

void init(float* a, DAD* a_dad){
  Group p = a_dad->grp();

  if(p.member()){
    Range x = a_dad->rng(0);
    int   s = a_dad->str(0);

    Block b;
    x.block(&b, x.dim().crd());

    for(int l=0; l < b.count; l++){
      const int i = b.glb_bas + b.glb_stp * l + 1;
      a [s * (b.sub_bas + b.sub_stp * l)] = 1.0 * i;
    }
  }
}

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  Procs2 q(2, 2);
  
  BlockRange x(6, q.dim(0)),
             y(50, q.dim(0));

  float* b = new float[x.volume() * y.volume()];

  // Create DAD for section b(1, :)

  Location i;
  x.location(&i, 1);

  Group p = q;
  p.restrict(q.dim(), i.crd);

  Map maps [1];
  maps [0] = Map(y, x.volume());

  DAD dad(1, p, maps);

  init(b + i.sub, &dad);

  } AdlibFinalize() ;
}
